#pragma once
class ScopedHandle
{
    HANDLE g_h;

public:
    ScopedHandle(HANDLE h, bool duplicate) noexcept;
    ScopedHandle(HANDLE h) noexcept : ScopedHandle(h, false) {}
    ScopedHandle() noexcept : ScopedHandle(nullptr) {}
    void Close();
    void Reset(HANDLE h);
    bool IsValid() const {
        return (g_h != nullptr) && (g_h != INVALID_HANDLE_VALUE);
    }

    PHANDLE Ptr()
    {
        return &g_h;
    }

    ScopedHandle(const ScopedHandle& other) noexcept;
    ScopedHandle& operator=(const ScopedHandle& other) noexcept;

    ScopedHandle(ScopedHandle&& other) noexcept;
    ScopedHandle& operator=(ScopedHandle&& other) noexcept;

    operator HANDLE() const {
        return g_h;
    }

    ~ScopedHandle();
};

